# Editor View

```plantuml
@startuml

set namespaceSeparator ::

namespace core::model {
  class Field {
    - String name
    - String description
  }

  class ValueField {
    - String value
    - uint bitsize
  }
  Field <|-- ValueField

  class ValidateableValueField {
    - Validator validator
  }
  ValueField <|-- ValidateableValueField

  class RegexValueField {
    - String regex
  }
  ValidateableValueField <|-- RegexValueField

  class FunctionField {
    - Function fnc
  }
  ValidateableValueField <|-- FunctionField

  class LayerTransitionField {
    - Layer nextLayer
  }
  Field <|-- LayerTransitionField
}
namespace editorview {
  class Layer {
    - int level
  }

  class FieldView {
    - Layer layer
    - Field field
  }
  core::model::Field --* FieldView

  core::model::ValueField --* ValueFieldView
  FieldView <|-- ValueFieldView
  core::model::ValidateableValueField --* ValidateableValueFieldView
  ValueFieldView <|-- ValidateableValueFieldView
  core::model::ValidateableValueField --* RegexValueFiledView
  ValidateableValueFieldView <|-- RegexValueFiledView
  core::model::FunctionField --* FunctionFieldView
  ValidateableValueFieldView <|-- FunctionFieldView
}
@enduml
```
