#ifndef AMODEL_H
#define AMODEL_H
#include <memory>
#include "../Tree.h"
#include "Field.h"
#include "../RandomAccessBinary.h"
#include "IModel.h"
#include <list>

namespace NPC_core {
namespace Model {
class Model : public IModel
{
public:
    Model();
    virtual ~Model(){}

    Tree<Field> getStack() const;
    std::list<std::shared_ptr<Structure>> getStructures() const;
    std::string getBinaryInHex() const;
    void addStructure(std::shared_ptr<Structure> structure);

    void update(); // updates the stack if a new structure has been added, and updates the binary

private:
    Tree<Field> stack;
    std::unique_ptr<RandomAccessBinary> rab;
    std::list<std::shared_ptr<Structure>> structures;
};
}}
#endif // AMODEL_H
