#include "StructureField.h"

namespace NPC_editor {

StructureField::StructureField(QWidget *parent) : QWidget(parent)
{
    this->field = nullptr;
    this->validator = new QRegExpValidator();
    this->layout = new QVBoxLayout(this);
    this->setLayout(layout);
    this->edit = nullptr;
    this->line = nullptr;
    this->title = new QLabel(this);
    this->syntax = new QLabel(this);
}

StructureField::StructureField(const std::shared_ptr<NPC_core::Model::Field> field, QWidget *parent) : QWidget(parent)
{
    this->field = field;
}

void StructureField::inputChanged()
{

}

void StructureField::dataChanged()
{

}

void StructureField::nodeChanged()
{

}

void StructureField::render()
{

}

void StructureField::initialRender()
{
    for (QObject* w : this->children())
        if (w->isWidgetType())
            this->layout->removeWidget((QWidget*)w);
    layout->addWidget(this->title);
    layout->addWidget(this->syntax);
    if (false ){// reference->getData()->isMultiLine()) {
        this->edit = new QTextEdit(this);
        layout->addWidget(this->edit);
    } else {
        this->line = new QLineEdit(this);
        layout->addWidget(this->line);
    }
    this->render();
}

}
