#ifndef STRUCTUREFIELD_H
#define STRUCTUREFIELD_H

#include <QWidget>
#include <QLabel>
#include <QTextEdit>
#include <QLineEdit>
#include <QVBoxLayout>
#include <QRegExpValidator>
#include "../core/model/Field.h"
#include <memory>

namespace NPC_editor {

class StructureField : public QWidget
{
    Q_OBJECT
public:
    explicit StructureField(QWidget *parent = nullptr);
    explicit StructureField(const std::shared_ptr<NPC_core::Model::Field> field, QWidget *parent = nullptr);

signals:


public slots:
    void inputChanged();
    void dataChanged();
    void nodeChanged();
    void render();
    void initialRender();

private:
    std::shared_ptr<NPC_core::Model::Field> field;
    // layout
    QVBoxLayout* layout;
    QLabel* title;
    QLabel* syntax;
    QTextEdit* edit;
    QLineEdit* line;
    QMap<QString, QWidget*> otherWidgets;
    QRegExpValidator* validator;
    QWidget* subContainer;
};
}
#endif // STRUCTUREFIELD_H
