#ifndef GUIDEDEDITORELEMENTVIEW_H
#define GUIDEDEDITORELEMENTVIEW_H

#include <QComboBox>
#include <QLabel>
#include <QLineEdit>
#include <QList>
#include <QVBoxLayout>
#include <QWidget>
#include <QTextEdit>
#include <memory>

#include "editorelementdata.h"
#include "../core/TreeNode.h"
#include "../model/Field.h"

class GuidedEditorElementView : public QWidget {
    Q_OBJECT
public:
    explicit GuidedEditorElementView(const std::shared_ptr<TreeNode<Field>> &ref,QWidget* parent = 0);
    explicit GuidedEditorElementView(QWidget* parent = 0);


    std::shared_ptr<TreeNode<Field>> getReference() const;
    void setReference(const std::shared_ptr<TreeNode<Field>> &value);

signals:

public slots:
    void inputChanged();
    void dataChanged();
    void nodeChanged();
    void render();

private:
    // layout
    QVBoxLayout* layout;
    QLabel* title;
    QTextEdit* edit;
    QLineEdit* line;
    QMap<QString, QWidget*> otherWidgets;
    QRegExpValidator* validator;
    QWidget* subContainer;
    std::shared_ptr<TreeNode<Field>> reference;
};

#endif // GUIDEDEDITORELEMENTVIEW_H
