#ifndef GUIDEDEDITOR_H
#define GUIDEDEDITOR_H
#include "../core/Tree.h"
#include "editorelementdata.h"
#include "guidededitorelementview.h"
#include "flowlayout.h"
#include <QWidget>
#include <memory>

class GuidedEditorView : public QWidget {
    Q_OBJECT
public:
    explicit GuidedEditorView(QWidget* parent = 0);
    explicit GuidedEditorView(Tree<Field>* tree, QWidget* parent = 0);
    ~GuidedEditorView();

signals:

public slots:
    void addElement(EditorElementData* element);
    void setTree(Tree<Field>* tree);

    void treeDataChangedSlot(std::shared_ptr<TreeNode<Field>> node);
    void treeChangedSlot(std::shared_ptr<TreeNode<Field>> node);

    void render();

private:
    FlowLayout* editorLayout;
    Tree<Field>* tree;
    QMap<std::shared_ptr<TreeNode<Field>>, GuidedEditorElementView*> nodeToViewMap;

};

#endif // GUIDEDEDITOR_H
