#ifndef DATALOADER_H
#define DATALOADER_H

#include <yaml-cpp/yaml.h>

#include <string>
#include <list>

#include "../core/TreeNode.h"
#include "../model/Field.h"


class DataLoader {
public:
    explicit DataLoader();
    explicit DataLoader(std::string directory);

    void loadProtocolDirectory(std::string directory);

    void loadSingleProtocol(std::string filename);

    std::shared_ptr<TreeNode<Field>> generateTree(YAML::Node &node);

    bool getProtocolByName(std::string name, YAML::Node &node);
    std::list<std::string> getProtocolNames();

private:
    std::shared_ptr<TreeNode<Field>> genNode(YAML::Node& n, std::shared_ptr<TreeNode<Field>> parent = nullptr);
    std::string directory;
    std::list<YAML::Node> protocolList;
};


#endif // DATALOADER_H
